<script setup>

    import { useRequiredInputEventListener, useRemoveRequiredInputEventListener } from "~/composables/graphics.js";

    const props = defineProps({
        img: {
            type: String,
            required: false
        },
        text: {
            type: String,
            default: ""
        },
        type: {
            type: String,
            default: "text"
        },
        value: {
            type: String
        },
        width: {
            type: String,
            default: ""
        },
        maxlength: {
            type: String,
            default: ""
        },
        bg: {
            type: String,
            default: ""
        },
        id: {
            type: String
        },
        details: {
            type: String,
            default: ""
        },
        is_mandatory: {
            type: Boolean,
            default: false
        },
        button_id: {
            type: String
        },
        extend_class: {
            type: String,
            required: false,
            default: ""
        }
    });

    // Add event listener on button-click if this input is required
    onMounted(() => {
        if(props.is_mandatory && props.id != null && props.button_id != null) {
            useRequiredInputEventListener(props.id, props.button_id);
        }
    });
    // Remove event listener on button-click if this input is required
    onUnmounted(() => {
        if(props.is_mandatory && props.id != null && props.button_id != null) {
            useRemoveRequiredInputEventListener(props.id, props.button_id);
        }
    })

    const placeholder = computed(() => {
        return (props.is_mandatory) ? props.text + "*" : props.text;
    });

    const emit = defineEmits(['value','blur']);

    function emitValue(e) {
        emit("value", e.target.value);
    }

    function emitBlur(e) {
        emit("blur", e.target.value);
    }

</script>

<template>
    <textarea v-if="type=='textarea'"
        @input="emitValue" 
        @blur="emitBlur"
        :id="`${id}`"
        :value="value" 
        :type="type"
        :placeholder="`${placeholder}`" 
        :maxlength="maxlength"
        :class="`${width} ${details} ${bg} ${extend_class} min-w-0 p-[2px] placeholder:text-black rounded-[10px] shadow-las focus:placeholder:text-neutral-200`"
    ></textarea>
    <div v-else-if="img!=null" class="flex flex-row bg-white shadow-las rounded-[10px] pl-2 space-x-2">
        <img :src="img" width="20px" height="20px">
        <input 
            @input="emitValue"
            @blur="emitBlur"
            :id="`${id}`"
            :value="value"
            :type="type"
            :placeholder="`${placeholder}`"
            :maxlength="maxlength"
            :class="`${width} ${details} ${bg} ${extend_class} min-w-0 p-[2px] placeholder:text-black rounded-[10px] focus:placeholder:text-neutral-200`"
        >
    </div>
    <input v-else
        @input="emitValue"
        @blur="emitBlur"
        :id="`${id}`"
        :value="value"
        :type="type"
        :placeholder="`${placeholder}`"
        :maxlength="maxlength"
        :class="`${width} ${details} ${bg} ${extend_class} min-w-0 p-[2px] placeholder:text-black rounded-[10px] shadow-las focus:placeholder:text-neutral-200`"
    >
</template>